import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  private Professor emp;
  private long loadTime;
  long REFRESH_THRESHOLD = 3000;
  
  public void createProfessor(Professor employee){
    em.persist(employee);
  }
  
  
  public void loadProfessor(int id) {
    emp = em.find(Professor.class, id);
    if (emp == null)
      throw new IllegalArgumentException("Unknown employee id: " + id);
    loadTime = System.currentTimeMillis();
  }

  public Professor getProfessor() {
    return emp;
  }

  public void deductProfessorVacation(int days) {
    refreshProfessorIfNeeded();
    emp.setVacationDays(emp.getVacationDays() - days);
  }

  public void adjustProfessorSalary(long salary) {
    refreshProfessorIfNeeded();
    emp.setSalary(salary);
  }

  private void refreshProfessorIfNeeded() {
    if ((System.currentTimeMillis() - loadTime) > REFRESH_THRESHOLD) {
      em.refresh(emp);
      loadTime = System.currentTimeMillis();
    }
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }

}